#!/usr/bin/octave --silent
#
# You'll need to use the .octaverc in this directory to get the proper
# paths. You can pass it an integer on the command-line to specify how
# many times we should run the test suite in succession. The default
# is 1.
#

addpath('./unit_test');

global unittest_results;

unit_init(1, {});

test_files = glob('tests/*.m');

loop_count = 1;
arg_list = argv();
if (length(arg_list) > 0)
  loop_count = str2num(arg_list{1});
end

## Source every file that matches the glob above.
for idx = [ 1 : loop_count ]
  cellfun(@source, test_files);
end


fprintf('\n');
fprintf('Total tests attempted: %d\n', unittest_results.total);
fprintf('Total tests passed: %d\n', unittest_results.pass);
fprintf('Total tests failed: %d\n', unittest_results.fail);
